package ADS;

/**
 * berschrift:   Classes zur LV  "Algorithmen u. Datenstrukturen"
 * Beschreibung:
 * Copyright:     Copyright (c) 2002
 * Organisation:  HTWK Leipzig, Fb IMN
 * @author Prof. Dr. G. Ngler
 * @version 1.0
 */
 import java.io.RandomAccessFile;

 public abstract class Elementtyp {
/** Implementation eines Basistyps fr Elemente, die ber einen Schlssel
 *  identifiziert werden.
 */
  public static final int AnzSchlSt=5;
                          //max. Anzahl der Stellen des Schlssel-Strings
  public static final int Radix=37;
                          //Anzahl der zur Schlsselbildung verwendeten Zeichen

  public abstract String getSchluessel();

  public static Elementtyp laden(RandomAccessFile file) { return null; }

  public void speichern(RandomAccessFile file) { }

  public boolean hatVorrangVor(Elementtyp EN)
  /** Eine Vorrang-Funktion: Das Element mit dem lexikographisch kleineren
   *  Schlssel hat Vorrang.
   */
  { return getSchluessel().compareTo(((Elementtyp) EN).getSchluessel()) < 0; }

  public static String ZahlZuSchl(int i) {
    StringBuffer sb= new StringBuffer(String.valueOf(i));
    int anz=5-sb.length();
    for (int k=1; k<=anz; k++) sb.insert(0,' ');
    return new String(sb);
  }

  public static int ZWert(char c)
  /** Bestimmt einen Wert fr ein Zeichen.
    */
  { int i=0; i=Character.getNumericValue(c);
    if (0<=i && i<36) return i+1; else return 0;
  }

  public static int ZWert(String s, int k)
  /** Bestimmt einen Wert fr die k-te Stelle von links im (Schlssel-)String s;
   *  = 0, wenn der String weniger als k Stellen hat.
   */
  { int i=0;
    if (0<=k && k<s.length()) i=ZWert(s.charAt(k));
    return i;
  }

  public static int[] mod2Hoch(int z) {
  /** Die Zahl z wird in die maximale Zweierpotenz (result[2]) und den
   *  ganzzahligen berschuss (result[0]) zerlegt. result[1]=Exponent
   */
    int [] result=new int[3]; int anz=0, Z=z;
    if (z>0) {
      while (Z!=0) { Z=Z>>>1; anz++; }
      result[2]=1<<(anz-1);
      result[0]=z-result[2]; result[1]=anz-1;
    }
    else { result[0]=0; result[1]=0; }
    return result;
  }

  public static int BHoch(int B, int k) {
    int Result=1; for (int i=1; i<=k; i++) Result=Result*B;
    return Result;
  }

 public static int ZweiHoch(int exp) {
   int result=1;
   if (exp>0) result=result << exp;
   return result;
 }

}
