package ADS;

import javax.swing.*;

public class Graph {
    int maxKnAnz;
    int maxBgAnz;
    Knoten[] Knotenliste;
    Bogen[]  Bogenliste;
    public   int n;
    public   int m;
    public   int WrzBg;

    public Graph(int maxKnAnz, int maxBgAnz) {
      this.maxKnAnz=maxKnAnz; this.maxBgAnz=maxBgAnz; WrzBg=maxBgAnz+1;
      Knotenliste=new Knoten[maxKnAnz];
      Bogenliste =new Bogen[maxBgAnz];
    }

    public Graph() {}

    public void clear() { n=0; m=0; }

    public String KnName(int i)
    /**  KnName(i) gibt fr eine gltige Knotennummer, istKn(i) = true oder
     *  1 <= i <= n(), die String-Bezeichnung des Knotens.
     */
    {
      if (istKn(i)) return Knotenliste[i-1].name; else return new String();
    }

    public int KnNr(String KnName, boolean found) {
    /**  berprft, ob in der Knotenliste ein Knoten mit der Bezeichnung KnName
     *   existiert und gibt gegebenenfalls dessen Nummer zurck.
     *   Wird die Methode mit found=true aufgerufen und der Knoten existiert noch
     *   nicht, so wird ein neuer Knoten an die Knotenliste angehngt.
     */
      boolean add=found; found=false; int i=0;
      while (!found && i<n) {
      	found=KnName.equals(Knotenliste[i].name);
        if (!found) i++;
      };
      if (!found)
        if (n<maxKnAnz && add) {
          n++; Knotenliste[i]=new Knoten(KnName);
        }
        else i=-1;
      return i+1;
    }

    public void insertBg(String von, String nach){
    /**  An die Bogenliste wird ein neuer Bogen angehngt. Falls einer seiner
     *   Knoten, Anfangsknoten=von oder Endknoten=nach, noch nicht existiert,
     *   so wird gleichzeitig ein neuer Knoten an die Knotenliste angehngt.
     *   Die Methode ist die einzige Mglichkeit, einen Graphen zu erweitern.
     */
      int i=KnNr(von,true);
      if (i!=0) {
	int j=KnNr(nach,true);
        if (j!=0) {
	  m++;
          Bogenliste[m-1]=new Bogen(i,j);
          int Aus=Knotenliste[i-1].AusBg;
	  if (Aus==0) Knotenliste[i-1].AusBg=m;
	  else {
	    int k=Bogenliste[Aus-1].nAusBg;
	    while (k!=0) { Aus=k; k=Bogenliste[Aus-1].nAusBg; }
  	    Bogenliste[Aus-1].nAusBg=m;
          }
          int Ein=Knotenliste[j-1].EinBg;
          if (Ein==0) Knotenliste[j-1].EinBg=m;
          else {
            int k=Bogenliste[Ein-1].nEinBg;
            while (k!=0) { Ein=k; k=Bogenliste[Ein-1].nEinBg; }
            Bogenliste[Ein-1].nEinBg=m;
          }
        }
      }
    }

    public boolean istKn(int i) { return (0<i) && (i<=n);}

    public boolean istBg(int k) { return ((0<k) && (k<=m)) || ((0<-k) && (-k<=m));}

    public int AKn(int k)
    /**  Nummer des Anfangsknotens des k-ten Bogens der Bogenliste.
     *   AKn(-k) = EKn(k)
     */
    {
	if (istBg(k))
          if (k>0) return Bogenliste[ k-1].AKn;
	  else     return Bogenliste[-k-1].EKn;
        else return 0;
    }

    public int EKn(int k)
    /**  Nummer des Endknotens des k-ten Bogens der Bogenliste. EKn(-k) = AKn(k)
     */
    {
      if (istBg(k))
	if (k>0) return Bogenliste[ k-1].EKn;
	else     return Bogenliste[-k-1].AKn;
      else return 0;
    }

    public int eEinBg(int i)
    /**  - ein (erster) Bogen, dessen Endknoten i ist ("Eingangsbogen" in i)
     *   0, wenn istKn(i) = false.
     */
    {
      if (istKn(i)) return Knotenliste[i-1].EinBg;
      else return 0;
    }

    public int nEinBg(int i, int k)
    /**  nEinBg(i,k) ein auf den Bogen mit der Nummer k folgender Bogen,
     *  dessen Endknoten i ist. 0, wenn kein solcher Bogen existiert.
     */
    {
      if (istKn(i) && (EKn(k)==i))
	if (k>0) return  Bogenliste[ k-1].nEinBg;
	else     return -Bogenliste[-k-1].nAusBg;
      else return 0;
    }

    public int eAusBg(int i)
    /**  - ein (erster) Bogen, dessen Anfangsknoten i ist ("Ausgangsbogen" aus i).
     *   0, wenn istKn(i) = false.
     */
    {
      if (istKn(i)) return Knotenliste[i-1].AusBg;
      else return 0;
    }

    public int nAusBg(int i, int k)
    /**  nAusBg(i,k) ein auf den Bogen mit der Nummer k folgender Bogen,
     *  dessen Anfangsknoten i ist. 0, wenn kein solcher Bogen existiert.
     */
    {
      if (istKn(i) && (AKn(k)==i))
	if (k>0) return  Bogenliste[ k-1].nAusBg;
	else     return -Bogenliste[-k-1].nEinBg;
      else return 0;
    }

    public int eInzBg(int i)
    /**  - ein (erster) Bogen, der mit dem Knoten i inzidiert.
     *   Die Nummer wird negativ geliefert, wenn der Bogen Eingangsbogen bei i
     *   ist. 0, wenn istKn(i) = false.
     */
    {
      int Result=0;
      if (istKn(i)) {
	Result=-Knotenliste[i-1].EinBg;
	if (Result==0) Result=Knotenliste[i-1].AusBg;
      };
      return Result;
    }

    public int nInzBg(int i, int k)
    /** - ein auf den Bogen mit der Nummer k folgender Bogen, der inzident mit i
     *  ist. Die Nummer wird negativ geliefert, wenn der Bogen Eingangsbogen bei
     *  i ist. 0, wenn kein solcher Bogen existiert.
     */
    {
      int Result=0;
      if (istKn(i) && AKn(k)==i)
	if (k<0) {
	  Result=-Bogenliste[-k-1].nEinBg;
          if (Result==0) Result=Knotenliste[i-1].AusBg;
        }
	else Result=Bogenliste[k-1].nAusBg;
      return Result;
    }

    public void  setStzBg(int i, int k)
    /** Setzt den (mit i inzidenten) Gerstbogen k als  "Sttzbogen" des
     *  Knotens i.
     */
    {
      if (istKn(i)) Knotenliste[i-1].StzBg=k;
    }

    public int   getStzBg(int i)
    /** Liefert den (mit i inzidenten) "Sttzbogen" des Knotens i.
     */
    {
      if (istKn(i)) return Knotenliste[i-1].StzBg; else return 0;
    }

    public void  initStzBg(int Start)
    /** Initialisiert ein Gerst indem der Knoten Start als Wurzel erklrt wird
     *  und alle brigen Knoten 0 als "Sttzbogen" erhalten.
     */
    {
      for (int i=1;  i<=n; i++) Knotenliste[i-1].StzBg=0;
      if (istKn(Start)) Knotenliste[Start-1].StzBg=WrzBg;
    }

    public int   StzRchtg(int k)
    /** Liefert -1, wenn -k Sttzbogen AKn(k) ist.
     *  Liefert  0, wenn k kein Gerstbogen ist.
     *  Liefert  1, wenn  k Sttzbogen EKn(k) ist.
     */
    {
      if (istBg(k))
      	if (k>0)
	  if (getStzBg(EKn(k))==k) return 1;
	  else if (getStzBg(AKn(k))==-k) return -1;
               else return 0;
        else return -StzRchtg(-k);
      else return 0;
    }

    public void  setzWrz(int i)
    /** Verschiebt die Wurzel eines vorhandenen Gerstes in den Knoten i. */
    {
      int l; int j=i;
      if (istKn(j)) {
        int k=WrzBg;
	do {
          l=getStzBg(j); setStzBg(j,k); j=AKn(l); k=-l;
        } while (l!=WrzBg && j!=0);
      }
    }

    public boolean istWrz(int i) {  return (getStzBg(i)==WrzBg); }

    public void  tauschStzBg(int kAlt, int kNeu)
    /** Nimmt den Bogen kNeu in die Menge der Sttzbgen auf und entfernt aus
     *  dieser kAlt, falls kAlt/=0.
     */
    {
      if (istBg(kNeu)) {
        setzWrz(EKn(kNeu)); setStzBg(EKn(kNeu),kNeu);
        int i=EKn(kAlt*StzRchtg(kAlt));
	      if (kAlt!=0) setStzBg(EKn(kAlt*StzRchtg(kAlt)),WrzBg);
      }
    }

    public void  setMarke(int i, int k)
    /** Setzt den Wert einer "Marke" am Knoten i. */
    {
      if (istKn(i)) Knotenliste[i-1].Marke=k;
    }

    public int   getMarke(int i)
    /** Liefert den Wert der "Marke" am Knoten i. */
    {
      if (istKn(i)) return Knotenliste[i-1].Marke; else return 0;
    }

    public void  initMarke(int Wert)
    /** Initialisiert eien Knotenmarkierung indem Marke(i)=Wert fr
     *  alle Knoten gesetzt wird.
     */
    {
      for (int i=0;  i<n; i++) Knotenliste[i].Marke=Wert;
    }

    public void  markCZ(int k)
    /** Initialisiert die Knotenmarkierung Marke(i) so, dass sie den Cozyklus
     *  zum Bogen k kennzeichnet, vorausgesetzt k ist Gerstbogen.
     */
    {
      int i; int j; int Ma;
      if (istBg(k) && StzRchtg(k)!=0) {
	setzWrz(AKn(k));
	for (i=1; i<=n; i++)
          if (getStzBg(i)==WrzBg) setMarke(i,1); else setMarke(i,0);
	  setMarke(EKn(k),2);
	  for (i=1; i<=n; i++)
	    if (getMarke(i)==0) {
	      j=i;
              while (getMarke(j)==0) j=AKn(getStzBg(j));  Ma=getMarke(j);
	      j=i;
              while (getMarke(j)==0) { setMarke(j,Ma); j=AKn(getStzBg(j)); }
            }
      }
    }

    public int   czKoeff(int k)
    /** Wurde markCZ aufgerufen, so liefert czKoeff(k) -1, wenn k als
     *  Eingangsbogen zum markierten Cozyklus gehrt, 1, wenn k als
     *  Ausgangsbogen zum markierten Cozyklus gehrt und 0, wenn k nicht zum
     *  markierten Cozyklus gehrt.
     */
    {
      if (istBg(k)) return getMarke(EKn(k))-getMarke(AKn(k)); else return 0;
    }

    public void  setX(int k, double x)
    /** Setzt den Wert x als Fluss des Bogens k. */
    {
      if (istBg(k))
        if (k>0) Bogenliste[k-1].x=x; else Bogenliste[-k-1].x=-x;
    }

    public void  setDx(int k, double dx)
    /** Setzt den Wert dx als nderungsfluss des Bogens k. */
    {
      if (istBg(k))
        if (k>0) Bogenliste[k-1].dx=dx; else Bogenliste[-k-1].dx=-dx;
    }

    public double getX(int k)
    /** Liefert den Wert des Flusses durch den Bogen k. */
    {
      if (istBg(k))
        if (k>0) return Bogenliste[k-1].x;
        else return -Bogenliste[-k-1].x;
      else return 0;
    }

    public double getDx(int k)
    /** Liefert den Wert des nderungsflusses durch den Bogen k. */
    {
      if (istBg(k))
        if (k>0) return Bogenliste[k-1].dx;
        else return -Bogenliste[-k-1].dx;
      else return 0;
    }

    public void initX()
    /** Initialisiert einen Strom Fluss=0 fr alle Bgen. */
    {
      for (int k=1; k<=m; k++) setX(k,0);
    }

    public void initDx()
    /** Initialisiert einen nderungsstrom nderungsfluss=0 fr alle Bgen.  */
    {
      for (int k=1; k<=m; k++) setDx(k,0);
    }

    public void  setT(int i, double t)
    /** Setzt den Potentialwert  des Knotens i auf t. */
    {
      if (istKn(i)) Knotenliste[i-1].t=t;
    }

    public double getT(int i)
    /** Liefert den Potentialwert  des Knotens i. */
    {
      if (istKn(i)) return Knotenliste[i-1].t; else return 0;
    }

    public void initT(double wert)
    /** Initialisiert das Potential t=Wert fr alle Knoten */
    {
      for (int i=1; i<=n; i++) setT(i, wert);
    }

    public void  setDt(int i, double dt)
    /** Setzt den Wert des nderungspotentials des Knotens i auf dt. */
    {
      if (istKn(i)) Knotenliste[i-1].dt=dt;
    }

    public double getDt(int i)
    /** Liefert den Wert des nderungspotentials des Knotens i. */
    {
      if (istKn(i)) return Knotenliste[i-1].dt; else return 0;
    }

    public void initDt()
    /** Initialisiert das nderungspotential t=Wert fr alle Knoten */
    {
      for (int i=1; i<=n; i++) setDt(i,0.0);
    }

    public double getY(int k)
    /** Liefert die aus dem gegebenen Potential resultierende Spannung des
     *  Bogens k
     */
    {
      if (istBg(k)) return getT(EKn(k))-getT(AKn(k)); else return 0;
    }

    public double getDy(int k)
    /** Liefert die aus dem gegebenen nderungspotential resultierende Spannung
     *  des Bogens k
     */
    {
      if (istBg(k)) return getDt(EKn(k))-getDt(AKn(k)); else return 0;
    }

    public void  DFS(int Start)
    /** Tiefensuche ausgehend von Knoten Start. Resultat ist der durch
     *  getStzBg(i) beschriebene Baum.
     */
    {
      int i,j,k;
      initStzBg(Start);
      i=Start; k=eAusBg(i);
      do {
        while (istBg(k)) {
	  j=EKn(k);
          if (getStzBg(j)==0) { setStzBg(j,k); i=j; k=eAusBg(i); }
	  else k=nAusBg(i,k);
        }
        if (i!=Start) { k=getStzBg(i); i=AKn(k); k=nAusBg(i,k); }
      } while ((i!=Start) || istBg(k));
    }

    public void  BFS(int Start) {
    /** Breitensuche ausgehend vom Knoten Start. Resultat ist der durch
     *  getStzBg(i) beschriebene Baum.
     */
      int i,j,k;
      IntSchlange S=new IntSchlange(maxKnAnz);
      S.push(Start);
      initStzBg(Start);
      while (!S.istLeer()) {
	i=S.exTop();
	k=eAusBg(i);
	while (istBg(k)) {
	  j=EKn(k);
	  if (getStzBg(j)==0) { setStzBg(j,k); S.push(j);}
	  k=nAusBg(i,k);
        }
      }
    }

    public void  Zusammenhang(int Start) {
    /** Markiert alle mit Knoten Start zusammenhngenden Knoten i
     *  mit getStzBg(i)/=0.
     */
       int i,j,k;
      setStzBg(Start,WrzBg);
      i=Start; k=eInzBg(i);
      do {
        while (istBg(k)) {
	  j=EKn(k);
	  if (getStzBg(j)==0) { setStzBg(j,k); i=j; k=eInzBg(i); }
	  else k=nInzBg(i,k);
        }
	if (i!=Start) { k=getStzBg(i); i=AKn(k); k=nInzBg(i,k); }
      } while ((i!=Start) || istBg(k));
   }

    public int AnzZshgKomp() {
    /** Ermittelt die Anzahl der zusammenhngenden Komponenten. Die Knoten i
     *  einer Komponente werden mit getMarke(i)=Nr markiert,
     *  1 <= Nr <= AnzZshgKomp().
     */
      int i,Start,z,Anz;
      initStzBg(1); initMarke(0); Anz=1; Start=1;
      do {
        Zusammenhang(Start);
	z=0;
	for (i=1; i<=n; i++) {
	  if (getStzBg(i)!=0 && getMarke(i)==0) setMarke(i,Anz);
	  if (getMarke(i)!=0) z++;
        }
        if (z<n) {
	  Anz++;
	  Start=1;
          while (getMarke(Start)!=0) Start++;
        }
      } while (z<n);
      return Anz;
    }

    public void DFSruek(int Start) {
    /** Tiefensuche ausgehend vom Knoten Start, allerdings entgegen der
     *  Bogenrichtungen. Resultat ist der durch getStzBg(i) beschriebene Baum
     *  der Knoten, von denen aus man der Knoten Start erreichen kann.
     */
      int i,j,k;
      initStzBg(Start);
      i=Start; k=eEinBg(i);
      do {
        while (istBg(k)) {
          j=AKn(k);
	  if (getStzBg(j)==0) { setStzBg(j,k); i=j; k=eEinBg(i); }
	  else k=nEinBg(i,k);
        }
	if (i!=Start) { k=getStzBg(i); i=EKn(k); k=nEinBg(i,k); }
      } while ((i!=Start) || istBg(k));
    }

    public int AnzStarkZshgKomp() {
    /** Ermittelt die Anzahl der stark zusammenhngenden Komponenten. Die Knoten
     *  i einer Komponente werden mit getMarke(i)=w markiert,
     *  1 <= w <= AnzStarkZshgKomp().
     */
   initMarke(0);
   int w=0;
   for(int i=1;i<=n;i++){
     if(getMarke(i)==0){
       w++;
       DFS(i); //von i aus erreichbare Knoten ermitteln
       for(int j=1;j<=n;j++)
         if(getMarke(j)==0 && getStzBg(j)!=0)
           setMarke(j,w);
       DFSruek(i); //ist i auch von j aus erreichbar?
       for(int j=1;j<=n;j++)
         if(getMarke(j)==w && getStzBg(j)==0)
           setMarke(j,0);
     }
   }
   return w;
}


    public int[] TOrd() {
    /** Ermittelt eine topologische Ordnung. */
      int [] result=new int[2];
      result[0]=0; result[1]=0;
      return result;
    }

    public String printZyklus(int k) {
    /** Liefert einen String, der den Basiszyklus durch den Co-Gerstbogen
     *  k beschreibt.
     */
      int i; String S=new String("[ ");
      if (istBg(k) && StzRchtg(k)==0) {
        setzWrz(AKn(k)); i=EKn(k); S=S+KnName(AKn(k))+"->"+KnName(i);
	k=getStzBg(i);
        while (k!=WrzBg) {
          i=AKn(k);
	  if (k>0) S=S+", -("+KnName(i)+"->"+KnName(EKn(k))+")";
	  else S=S+", "+KnName(EKn(k))+"->"+KnName(i);
	  k=getStzBg(i);
        }
      }
      S=S+" ]"; return S;
    }

    public String printCozyklus(int k) {
    /** Liefert einen String, der den Basiscozyklus durch den Gerstbogen
     *  k beschreibt.
     */
      int i,r; String S=new String("{ ");
      if (istBg(k) && StzRchtg(k)!=0) {
        markCZ(k);
	for (k=1; k<=m; k++) {
          r=czKoeff(k);
	  if (r!=0) {
            if (!S.equals("{ ")) S=S+", ";
            if (r==-1) S=S+"-("+KnName(AKn(k))+"->"+KnName(EKn(k))+")";
	    else S=S+KnName(AKn(k))+"->"+KnName(EKn(k));
          }
        }
      }
      S=S+" }"; return S;
    }

    public void Analyse(JTextArea ausg) {
    /** Liefert Strings, mit Aussagen ber Zusammenhang bzw. starken
     *  Zusammenhang.
     */
    }

    public String Analyse()
    /** Liefert Strings, mit Aussagen ber Zusammenhang bzw. starken
     *  Zusammenhang.
     */
    {
      String str=new String();
      int nStark, nZus;
      for(int i=1;i<=n;i++){
        str=str+"Knoten "+i+": Marke="+getMarke(i);
        if(i%2!=0)  str+="\t";
        else  str+="\n";
      }
      str+="\n\n";
      nZus=AnzZshgKomp();
      nStark=AnzStarkZshgKomp();

      if(nZus==1 && nStark==1)
        str+="Der Graph besteht aus nur einer (stark) zusammenhngenden\n"+
            "Komponenten und bildet deshalb einen Kreis.\n";
      else if(nZus==nStark && nZus>1 && nZus<n)
        str+="Der Graph hat "+nZus+" zusammenhngende sowie stark\n"+
            "zusammenhngende Komponenten und ist nicht kreisfrei.\n";
      else if(nStark==n)
        str+="Der Graph hat "+nZus+" zusammenhngende Komponenten und\n"+
            "die Anzahl der stark zusammenhngenden Komponenten\n"+
            "entspricht der Anzahl der Knoten des Graphen ("+nStark+")\n"+
            "- demnach ist der Graph kreisfrei.\n";

      else if(nZus<nStark && nStark<n){
        str+="Anzahl der zusammenhngenden Komponenten ("+nZus+") kleiner\n"+
            "der Anzahl der stark zusammenhngenden Komponenten ("+nStark+")\n"+
            "kleiner n="+n+". ";
        //Kreise im Graphen zhlen:
        int ElemKomp[]=new int[nStark];
        int kreise=nStark;
        for(int i=1;i<=n;i++)  ElemKomp[getMarke(i)-1]++;
        for(int i=0;i<nStark;i++)
          if(ElemKomp[i]==1)
            kreise--;
        if(kreise==0)  str+="Der Graph ist kreisfrei.\n";
        else  str+="Der Graph besitzt "+kreise+" Kreise!\n";
      }
      return str;
    }

    private boolean existNchstMarke(int u) {
      int v=(u==1)? 0:1;
      boolean Result=true; boolean Abbr=false;
      int z=0; int i=n;
      while (!Abbr && (i>1)) {
        Abbr=(getMarke(i)==u && getMarke(i-1)==v);
        if (!Abbr) { if (getMarke(i)==v) z++; i--; }
      }
      if (Abbr) {
        setMarke(i-1,u);
        for (int j=i;     j<=i+z; j++) setMarke(j,v);
        for (int j=i+z+1; j<=n;   j++) setMarke(j,u);
      }
      else
        if (z<n-1) {
          initMarke(u);
          for (int j=1; j<=z+1; j++) setMarke(j,v);
        }
        else Result=false;
      return Result;
    }

    private boolean pruefUnabhaengigkeit() {
      boolean Result=true;
      int k=0;
      while (Result && k<m) {
        k++;
        Result=!(getMarke(AKn(k))==1 && getMarke(EKn(k))==1);
      }
      return Result;
    }

    private boolean pruefDominanz() {
      boolean Result=true; boolean OK=true;
      int i=0;
      while (Result && i<n) {
        i++; OK=getMarke(i)==1; int k=eInzBg(i);
        while (!OK && istBg(k)) {
          OK=getMarke(EKn(k))==1;
          if (!OK) k=nInzBg(i,k);
        }
        Result=OK;
      }
      return Result;
    }

    public int innStabZahl() {
      boolean OK=false;
      initMarke(1);
      while (!OK && existNchstMarke(1)) OK=pruefUnabhaengigkeit();
      int Result=0;
      if (OK)
        for (int i=1; i<=n; i++)
          if (getMarke(i)==1) Result++;
      return Result;
    }

    public int aeussStabZahl() {
      boolean OK=false;
      initMarke(0);
      while (!OK && existNchstMarke(0)) OK=pruefDominanz();
      int Result=0;
      if (OK)
        for (int i=1; i<=n; i++)
          if (getMarke(i)==1) Result++;
      return Result;
    }

  private int nchstBg(int i, int k) {
    k=nInzBg(i,k);
    if (istBg(k) && getMarke(AKn(k))==EKn(k)) k=nInzBg(i,k);
    return k;
  }

  public int Match() {
    boolean found; boolean hatPartner; boolean Abbr;
    int i; int j; int k; int Start; int z;
    initMarke(0); z=0;
    for (i=1; i<=n; i++) {
      hatPartner=getMarke(i)!=0;
      k=eInzBg(i);
      while (!hatPartner && istBg(k)) {
        j=EKn(k);
        if (getMarke(j)==0) {
          setMarke(i,j); setMarke(j,i); z=z+2; hatPartner=true;
        }
        else k=nInzBg(i,k);
      }
    }
    Start=0;
    while (z<n-1 && Start<n) {
      Start++;
      if (getMarke(Start)==0) {
        initStzBg(Start);
        i=Start; j=i; k=eInzBg(i);
        do {
          found=false;
          while (!found && istBg(k)) {
            j=EKn(k); found=getMarke(j)==0 && j!=Start;
            if (getMarke(j)!=0) {
              j=getMarke(j);
              if (getStzBg(j)==0) {
                setStzBg(j,k); i=j; k=eInzBg(i);
                if (istBg(k) && getMarke(AKn(k))==EKn(k)) k=nInzBg(i,k);
              }
              else k=nchstBg(i,k);
            }
            else if (!found) k=nchstBg(i,k);
          }
          if (!found && i!=Start) {
            k=getStzBg(i); i=AKn(k); k=nchstBg(i,k);
          }
        } while (!found && !(i==Start && !istBg(k)));
        if (found) {
          z=z+2; Abbr=false;
          do {
            setMarke(i,j); setMarke(j,i);
            if (i!=Start) {
              k=getStzBg(i); i=AKn(k); j=EKn(k);
            }
            else Abbr=true;
          } while (!Abbr);
        }
      }
    }
    return z;
  }

}