package ADS;

public class eNetz extends Graph
/** Fgt der Klasse Graph eine Bogenbewertung c(k) hinzu: c(-k) = -c(k),
 *  Eingabewert fr c(k) ist cOrig[k], fr k>0 && istBg(k).
 *  insertBg ist so erweitert, dass die Eingabe des Wertes cOrig in
 *  Stringform erfolgen kann - Standard: cOrig=="" --> c(k)=0.
 *  Auf einem eNetz knnen krzeste und lngste Wege sowie ein Minimalgerst
 *  ermittelt werden.
 */
{
  public final double Infinit=100000;
  public final double eps=0.0001;
  double [] cOrig;
  double [] dcLst;

  public eNetz(int maxKnAnz, int maxBgAnz) {
    super(maxKnAnz,maxBgAnz);
    cOrig=new double[maxBgAnz];
    dcLst=new double[maxBgAnz];
  }

  public eNetz(){}

  public double c(int k) {
    if (istBg(k))
      if (k>0) return cOrig[ k-1];
          else return cOrig[-k-1];
      else return 0;
  }

  public void insertBg(String von, String nach, String C){
    Double  co=new Double("0");
    Double dco=new Double("0");
    String S1,S2;
    int i=C.indexOf('+');
    if (i<0) { S1=C; S2=""; }
    else
      if (i==0) { S1=""; S2=C.substring(1,C.length()); }
      else { S1=C.substring(0,i); S2=C.substring(i+1,C.length()); }
    if (!S1.equals("")) try { co=new Double(S1);} catch(NumberFormatException ne){}
    if (!S2.equals("")) try {dco=new Double(S2);} catch(NumberFormatException ne){}
    super.insertBg(von, nach);
    cOrig[m-1]= co.doubleValue();
    dcLst[m-1]=dco.doubleValue();
  }

  public boolean kuerzesteWege(int Start) {
    /** Rckgabewert=false, wenn es Kreise negativer Lnge gibt.
     *  In diesem Fall schliet jeder Bogen k, der getY(k)-c(k)>eps erfllt,
     *  im Gerst einen Kreis negativer Lnge.
     */
    int j,k; PriorHeap Kandidaten; ElementtypRI ID;
    initT(Infinit); initStzBg(0);
    Kandidaten=new PriorHeap(m+1);
    Kandidaten.pushOpt(new ElementtypRI(0.0,WrzBg));
    while (!Kandidaten.istLeer()) {
      ID=(ElementtypRI) Kandidaten.exOpt();
      k=ID.getInt();
      if (k==WrzBg) j=Start; else j=EKn(k);
      if (getStzBg(j)==0) {
        setStzBg(j,k); setT(j,ID.getInhalt());
        k=eAusBg(j);
        while (istBg(k)) {
          if (getStzBg(EKn(k))==0)
            Kandidaten.pushOpt(new ElementtypRI(getT(AKn(k))+c(k),k));
          k=nAusBg(j,k);
        }
      }
    }
    /* schauen, ob Fehler durch neg. BgLngen entstanden sind und versuchen zu *
     * korrigieren; funktioniert nicht bei negativen Kreisen!                  */
    double maxDt; int minBg;
    for(k=1;k<=m;k++){
      if(getY(k)-c(k)>eps){
        setzWrz(AKn(k));
        if(StzRchtg(EKn(k))<0) return false;
        else{
          do{
            markCZ(getStzBg(EKn(k)));
            maxDt=getY(k)-c(k); minBg=k;
            for(j=1;j<=m;j++)
              if(czKoeff(j)==-1 && maxDt>c(j)-getY(j))
                { maxDt=c(j)-getY(j); minBg=j; }
            for(j=1;j<=n;j++)
              if(getMarke(j)==2) setT(j,getT(j)-maxDt);
            setStzBg(EKn(minBg),minBg);
          }while(minBg!=k);
        }
        setzWrz(Start);
      }
    }
    return true;
  }

  public int[] tOrd(int Start) {
  /** - liefert mit Result[1]..Result[N] Knoten in topologischer Ordnung;
   *  N=Result[0]=Anzahl der Knoten, die von Quellen bzw. von Start (wenn /=0)
   *  aus geordnet werden knnen.
   *  (N=n, wenn das Netz kreisfrei ist)
   */
    int i,j,k,s,sA,sE,z; boolean Abbr;
    int[] result=new int[n+1];
    int[] AnzEinBg=new int[n+1];
    if (Start!=0) {result[1]=Start; z=1; } else z=0;
    for (i=1; i<=n; i++)
      if (i!=Start) {
        AnzEinBg[i]=0;
        k=eEinBg(i);
        while (istBg(k)) {
          if(c(k)>0) AnzEinBg[i]++;
          k=nEinBg(i,k);
        }
        if (AnzEinBg[i]==0) { z++; result[z]=i; }
      }
    sA=1; sE=z; Abbr=(z==0);
    while (!Abbr) {
      Abbr=true;
      for (s=sA; s<=sE; s++) {
        i=result[s];
        k=eAusBg(i);
        while (istBg(k)) {
          if (c(k)>0) {
            j=EKn(k);
            AnzEinBg[j]--;
            if (AnzEinBg[j]==0) { z++; result[z]=j; Abbr=false; }
          }
          k=nAusBg(i,k);
        }
      }
      if (!Abbr) { sA=sE+1; sE=z; }
    }
    result[0]=z;
    return result;
  }

  public boolean laengsteWege(int Start) {
  /** Das Netz sollte im Normalfall kreisfrei sein. In diesem Fall ist die
   *  Angabe von Start unntig (Start=0): Die Quellen sind die Starknoten.
   *  Der Rckgabewert ist false, wenn der Graph Kreise positiver Lnge enthlt.
   *  In diesem Fall schliet jeder Bogen k, der getY(k)-c(k)<eps erfllt, im
   *  Gerst einen Kreis negativer Lnge.
   */
    double T; int i,k;
    int[] tOrd=tOrd(Start);
    initT(-Infinit);
    int N=tOrd[0];
    i=tOrd[1];
    setStzBg(i,WrzBg); setT(i,0);
    for (int z=2; z<=N; z++) {
      i=tOrd[z]; setStzBg(i,WrzBg);
      k=eEinBg(i);
      while (istBg(k)) {
        T=getT(AKn(k))+c(k);
        if (T>getT(i) || (T==getT(i) && getStzBg(i)==WrzBg)) {
          setT(i,T); setStzBg(i,k);
        }
        k=nEinBg(i,k);
      }
    }
    boolean posKreis=false; double dY,maxY; int k1,kS,kMax;
    for (k=1; k<=m; k++) {
      dY=c(k)-getY(k);
      if (dY>eps) {
        setzWrz(AKn(k));
        kS=getStzBg(EKn(k));
        posKreis=kS<0;
        if (!posKreis) {
          do {
            kMax=k; maxY=c(k)-getY(k);
            if (kS==WrzBg) { initMarke(1); setMarke(EKn(kS),2); } else markCZ(kS);
            for (k1=1; k1<=m; k1++)
              if (czKoeff(k1)==-1 && getY(k1)-c(k1)<maxY)  {
                maxY=getY(k1)-c(k1); kMax=k1;
              }
            for (i=1; i<=n; i++) if (getMarke(i)==2) setT(i,getT(i)+maxY);
            setStzBg(EKn(kMax),kMax);
          } while (kMax!=k);
        }
        setzWrz(Start);
      }
    }
    return !posKreis;
  }

  public double minimalgeruest() {
    int j,k; PriorHeap Kandidaten; ElementtypRI ID;
    double result=0,cAbs;
    initStzBg(0);
    Kandidaten=new PriorHeap(m+1);
    Kandidaten.pushOpt(new ElementtypRI(0.0,WrzBg));
    while (!Kandidaten.istLeer()) {
      ID=(ElementtypRI) Kandidaten.exOpt();
      k=ID.getInt();
      if (k==WrzBg) j=1; else j=EKn(k);
      if (getStzBg(j)==0) {
        setStzBg(j,k); if (j!=1) result=result+c(k);
        k=eInzBg(j);
        while (istBg(k)) {
          if (getStzBg(EKn(k))==0) {
            if (k<0) cAbs=-c(k); else cAbs=c(k);
            Kandidaten.pushOpt(new ElementtypRI(cAbs,k));
          }
          k=nInzBg(j,k);
        }
      }
    }
    return result;
  }

}

